###################################################
# DNS server for hooking Pokemon DNS lookup       #
# Redirects GTS related communication to a custom #
# webserver and handles the rest in PHP           #
#   Written by Vladinator (at least some of it)   #
###################################################

#!/usr/bin/python
import socket, sys, time, thread

# What IP to redirect requests to
webserv_addr ="84.202.82.24"

# Force only redirection for these domains (populate this array, and skip list is ignored)
force_domains = ["gamestats2\x02gs\x0Cnintendowifi\x03net"]

# What domains should be skipped
skip_domains = []

# Just trying making the visuals more pretty :)
def domrepl(name):
  name=name.replace("\x02", ".")
  name=name.replace("\x03", ".")
  name=name.replace("\x0C", ".")
  return name
def dom2str(data):
  cut=data[13:len(data)-5]
  return domrepl(cut)
def domsuf(name):
  name=domrepl(name)
  if name[len(name)-1:] == ".":
    return name[0:len(name)-1]
  return name

# Class created by Francisco Santos (activestate#491264)
class dnsserv:
  def __init__(self, data):
    self.data=data
    self.domain=""

    type=(ord(data[2]) >> 3) & 15
    if type == 0:
      pos=12
      int=ord(data[pos])
      while int !=0:
        self.domain+=data[pos+1:pos+int+1]+'.'
        pos+=int+1
        int=ord(data[pos])

  def request(self, ip):
    packet=""
    if self.domain:
      packet+=self.data[:2] + "\x81\x80"
      packet+=self.data[4:6] + self.data[4:6] + "\x00\x00\x00\x00"
      packet+=self.data[12:]
      packet+="\xc0\x0c"
      packet+="\x00\x01\x00\x01\x00\x00\x00\x3c\x00\x04"
      packet+=str.join("",map(lambda x: chr(int(x)), ip.split(".")))
    return packet

# Simple func to fetch users IP (local one)
def myip():
  con=socket.socket();
  con.connect(("google.com",80));
  return con.getsockname()[0]

# Check request data with arrays
def shouldSkip(data):
  global force_domains, skip_domains
  skip=None
  if len(force_domains) == 0:
    for elem in skip_domains:
      if elem in data:
        #print "[S-Matched] '%s' -> '%s'/'%s'"%(elem, data, toHex(data))
        skip=elem
  else:
    skip=dom2str(data)
    for elem in force_domains:
      if elem in data:
        #print "[F-Matched] '%s' -> '%s'/'%s'"%(elem, data, toHex(data))
        skip=None
  if skip is not None:
    skip=domrepl(skip)
  return skip

# Fallback values
try:
  webserv_addr
except NameError:
  webserv_addr=myip()
try:
  force_domains
except NameError:
  force_domains=[]
try:
  skip_domains
except NameError:
  skip_domains=[]

# Hook func that handles the DNS requests
def hook(ip, dummy=None):
  con=socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
  con.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
  con.bind(("0.0.0.0",53))
  print "Server started, redirecting requests to: %s"%ip
  print "Waiting for connections..."
  try:
    while 1:
      data, addr=con.recvfrom(512)
      skip=shouldSkip(data)
      
      # If skip is defined, fetch real DNS results
      if skip is not None:
        realdns=socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        realdns.connect(("4.2.2.2",53))
        realdns.send(data)
        realdat=realdns.recv(512)
        con.sendto(realdat, addr)
        print "[Real:%s] \"%s\" (buypass)"%(domsuf(addr[0]), skip)
        
      # Otherwise hook the request and force the client to connect to our IP
      else:
        fakedns=dnsserv(data)
        con.sendto(fakedns.request(ip), addr)
        print "[Hook:%s] \"%s\" -> \"%s\""%(domsuf(addr[0]), fakedns.domain, ip)
  except Exception:
    con.close()

# The main entry point of this application
ran=time.clock()
if __name__ == "__main__":
  print "Starting DNS server, please wait..."
  thread.start_new_thread(hook, (webserv_addr, 1))

# Sleep until CTRL+C (interrupt) is found, then say bye and exit
while 1:
  try:
    time.sleep(1)
  except KeyboardInterrupt:
    ran=time.clock()-ran
    print "Closing connections... done! (ran for %d seconds)"%ran
    exit(0)
