<?php
/* 
 * Written by Vladinator (vladix2-gmail.com)
 * http://projectpokemon.org/forums/showthread.php?780
 */

if(substr($_SERVER['HTTP_USER_AGENT'], 0, 11) != "GameSpyHTTP") {
  header("Location: ./logs/");
  die();
}

#error_reporting(0);
session_cache_expire(2); // 2 min session expire per client
session_start();

$pure_log = 1;

$pkmlib = "pkmlib.py";
$servwww = "D:\\Apache\\www";
$servroot =  str_replace("\\", "/", str_replace($servwww, "", str_replace(end(explode("\\", __file__)), "", __file__)));
$out = "";

if(!file_exists($pkmlib))
  die("Fatal error, missing Python script {$pkmlib}!");

$pkmdist = 1;
$pkmfile = "arceus.pkm";
if(!file_exists($pkmfile)) $pkmdist = 0;
#print_r(pkmFileToBin($pkmfile));die();

$file = str_replace($servroot, "", $_SERVER['REDIRECT_URL']);
$filename = strtolower(str_replace(".asp", "", end(explode("/", $file, 2))));

if($pure_log || @substr($file, 0, 11) == "battletower") { // passes through all Battletower requests onto the official servers
  echo officialRequest($file);
  die();
  
} elseif(count($_GET) == 1) { // continues onto the GTS emulation (pid=hash generation)
  $population = array(array(48,57),array(65,90),array(97,122)); // 0-9, A-Z, a-z
  $token = "";
  for($i=1; $i<=32; $i++) {
    $cat = $population[rand(0, count($population)-1)];
    $token .= chr(rand($cat[0], $cat[1]));
  }
  $_SESSION['hash'] = sha1("sAdeqWo3voLeC5r16DYv".$token); // this will be the _GET[hash] value of the clients future requests, so far it's just for fun (we don't care!)
  $out .= $token;
  
} elseif($filename == "info") { // we have a pid, hash, and some data, but we ignore that and do what we want, muhaha!
  $out .= "\x01\x00";
  
} elseif($filename == "setprofile") {
  $out .= str_repeat("\x00", 8);
  
} elseif($filename == "result") {
  if($pkmdist) {
    if(isset($_SESSION['alreadysent'])) {
      $out .= "\x04\x00";
    } else $out .= pkmFileToBin($pkmfile);
  } else $out .= "\x05\x00";
  
} elseif($filename == "get") {
  if($pkmdist)
    $out .= pkmFileToBin($pkmfile);
  else
    $out .= "\x01\x00";
  
} elseif($filename == "return" || $filename == "delete") {
  $out .= "\x01\x00";
  if($pkmdist)
    $_SESSION['alreadysent'] = 1;
  
}

// output with neat server like headers (just for show)
@header("Date: ".date("D, j M Y H:m:i \G\M\T"), 1);
@header("Server: Microsoft-IIS/6.0", 1);
@header("P3P: CP='NOI ADMa OUR STP'", 1);
@header("cluster-server: aphexweb3", 1);
@header("X-Server-Name: AW4", 1);
@header("X-Powered-By: ASP.NET", 1);
@header("Content-Length: ".$filename == "setprofile" ? 8 : mb_strlen($out), 1);
@header("Content-Type: text/html", 1);
@header("Set-Cookie: ASPSESSIONIDQCDBDDQS=JFDOAMPAGACBDMLNLFBCCNCI; path=/", 1);
@header("Cache-control: private", 1);
echo $out;

// log the event...
$log = str_replace("pokemonegtspokemondpds", "", preg_replace("/[^A-Za-z0-9\.\_\-]*/", "", $_SERVER['REDIRECT_URL']))."_".microtime()."_.log";
$logtxt = file_exists($log) ? file_get_contents($log) : "";
if(strlen($log) > 5)
  @file_put_contents($log, $logtxt."\5\n\n".serialize($_SERVER['REDIRECT_URL'])."\5".serialize($_GET)."\5".serialize($_POST)."\5".serialize($_SESSION));

// helps create raw binary data from a PKM file and return it (if fails, sends a failsave \1\0 ascii code for "ok")
function pkmFileToBin($file) {
  global $pkmlib;
  $fname = @exec("{$pkmlib} \"{$file}\"");
  if(!empty($fname) && file_exists($fname))
    return file_get_contents($fname);
  return "\x01\x00";
}

function officialRequest($path) {
  $data = array();
  while(list($n,$v) = each($_GET))
    $data[] = $n."=".$v;
  $data = implode("&", $data);
  $gs2request = "http://gamestats2.gs.nintendowifi.net/pokemondpds/{$path}?{$data}";
  $raw = file_get_contents($gs2request);
  logRequest($raw, $path);
  return $raw;
}

function logRequest($raw, $path) {
  $log = array(
    "_SESSION"=>$_SESSION,
    "_GET"=>$_GET,
    "_POST"=>$_POST,
    "DATA"=>$raw,
    "_SERVER"=>$_SERVER,
  );
  $path = preg_replace("/[^A-Za-z0-9\.]*/", "", $path);
  $addr = preg_replace("/[^A-Za-z0-9\.]*/", "", $_SERVER['REMOTE_ADDR']);
  @mkdir("./logs/{$addr}/");
  $fname = "./logs/{$addr}/{$addr}_{$path}_".microtime().".log";
  if(!file_exists("./logs/{$addr}/.htaccess"))
    file_put_contents("./logs/{$addr}/.htaccess", "deny from all");
  if(file_exists($fname)) {
    file_put_contents($fname, file_get_contents($fname)."\5\n".serialize($log));
  } else {
    file_put_contents($fname, serialize($log));
  }
}
?>